SystemOrganization addCategory: #'1er-TP'!
SystemOrganization addCategory: #'1er-TP-ParaPruebas'!

Trait named: #CRT
	uses: {}
	category: '1er-TP'!

!CRT methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/18/2013 03:19'!
consumoPorHora
^5*(self tamanio).! !

!CRT methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/18/2013 03:19'!
definicionMaxima
^480.! !

!CRT methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/14/2013 08:50'!
tamanio
self requirement.! !

Trait named: #EntradaConCable
	uses: {}
	category: '1er-TP'!

!EntradaConCable methodsFor: 'as yet unclassified' stamp: 'LucasCostas 4/18/2013 14:38'!
cableDefinicion
	self requirement! !

!EntradaConCable methodsFor: 'as yet unclassified' stamp: 'LucasCostas 4/18/2013 14:38'!
cableTasaRefresco
	self requirement! !

!EntradaConCable methodsFor: 'as yet unclassified' stamp: 'LucasCostas 4/18/2013 20:27'!
definicionMaxima 
	^self cableDefinicion ! !

!EntradaConCable methodsFor: 'as yet unclassified' stamp: 'LucasCostas 4/18/2013 20:27'!
tasaDeRefresco 
	^self cableTasaRefresco ! !

Trait named: #EntradaQueAgregaPorcentajeDeConsumo
	uses: {}
	category: '1er-TP'!

!EntradaQueAgregaPorcentajeDeConsumo methodsFor: 'as yet unclassified' stamp: 'LucasCostas 4/18/2013 20:27'!
consumoPorHoraDe: unaPantalla 
	^unaPantalla consumoPorHora * self porcentajeAgregado.! !

!EntradaQueAgregaPorcentajeDeConsumo methodsFor: 'as yet unclassified' stamp: 'LucasCostas 4/18/2013 15:27'!
porcentajeAgregado 
	self requirement! !

Trait named: #EntradaValoresFijos
	uses: {}
	category: '1er-TP'!

!EntradaValoresFijos methodsFor: 'as yet unclassified' stamp: 'LucasCostas 4/18/2013 20:27'!
definicionMaxima 
	^480! !

!EntradaValoresFijos methodsFor: 'as yet unclassified' stamp: 'LucasCostas 4/18/2013 20:27'!
tasaDeRefresco 
	^50! !

Trait named: #Magnetico
	uses: {}
	category: '1er-TP'!

!Magnetico methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 4/17/2013 15:24'!
consume
	"Calcula el consumo de un disco rigido magnetico."

	| resultado |
	resultado := self rpm * 0.006.
	^resultado.! !

Trait named: #MonitorPC
	uses: {}
	category: '1er-TP'!

!MonitorPC methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:12'!
tasaDeRefresco
^120.! !

Trait named: #PdVAptoPVJBooleano
	uses: {}
	category: '1er-TP'!

!PdVAptoPVJBooleano methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 4/18/2013 01:22'!
noAptoParaJuegos
	"Responde si la placa de video onboard es apta para videojuegos"
	^false.! !

!PdVAptoPVJBooleano methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 4/18/2013 01:22'!
siAptoParaJuegos
	"Responde si la placa de video con GPU es apta para videojuegos"
	^true.! !

Trait named: #PdVAptoPVJCalculado
	uses: {}
	category: '1er-TP'!

!PdVAptoPVJCalculado methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 4/18/2013 02:17'!
aptoParaJuegos
	"Responde si la placa de video sin GPU es apta para videojuegos"
	| resultado |
	Float.
	resultado := ((self cantDePixeles)ln / self consume) > 4 .
	^resultado.! !

Trait named: #PdVDeConsumoCalculado
	uses: {}
	category: '1er-TP'!

!PdVDeConsumoCalculado methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 4/18/2013 17:11'!
consume
	"Calcula el consumo de una placa de video con GPU."

	| resultado |
	resultado := (( self cantDePixeles) * 0.00001) + self consumoDeCoolers.
	^resultado.! !

!PdVDeConsumoCalculado methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 4/18/2013 17:13'!
consume: unaCantDePixeles
	"Calcula el consumo de una placa de video con GPU, en base a una cantidad de pixeles dada."

	| resultado |
	resultado := ((unaCantDePixeles) * 0.00001) + self consumoDeCoolers.
	^resultado.! !

Trait named: #PdVDeConsumoCte
	uses: {}
	category: '1er-TP'!

!PdVDeConsumoCte methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 4/18/2013 00:15'!
consume
	"Calcula el consumo de una placa de video sin GPU.
	CONSTANTE"
	^self consumo + self consumoDeCoolers.! !

Trait named: #PlacaDeVideo
	uses: {}
	category: '1er-TP'!

!PlacaDeVideo methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 4/17/2013 16:41'!
consumoDeCoolers
	"Calcula el consumo de los coolers"
	^(self nroDeCoolers * 0.5).! !

Trait named: #Solido
	uses: {}
	category: '1er-TP'!

!Solido methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 4/17/2013 15:24'!
consume
	"Calcula el consumo de un disco rigido de estado solido.
	CONSTANTE."

	^self consumo.! !

Trait named: #TV
	uses: {}
	category: '1er-TP'!

!TV methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/14/2013 07:57'!
tasaDeRefresco 
^90.! !

Trait named: #TecnologiaDigital
	uses: {}
	category: '1er-TP'!

Trait named: #LCD
	uses: TecnologiaDigital
	category: '1er-TP'!

LCD classTrait
	uses: TecnologiaDigital classTrait!

!LCD methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/18/2013 03:24'!
consumoPorHora
^(4*self tamanio).! !

!LCD methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:20'!
tamanio
self requirement.! !

Trait named: #LED
	uses: TecnologiaDigital
	category: '1er-TP'!

LED classTrait
	uses: TecnologiaDigital classTrait!

!LED methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/18/2013 03:24'!
consumoPorHora 
^self tamanio.! !

!LED methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/14/2013 07:56'!
tamanio
self requirement.! !

!TecnologiaDigital methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/18/2013 03:23'!
definicionMaxima
^(self pixelesPorPulgada)*(((self tamanio raisedTo: 2)/2) sqrt).! !

!TecnologiaDigital methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:37'!
pixelesPorPulgada
self requirement.! !

TestCase subclass: #TPTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

!TPTests class methodsFor: 'history' stamp: 'SantiagoOcchiuzzi 4/14/2013 08:32'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #test5ConsumoDiscoMagnetico; add: #test5ConsumoPlacaOnBoard; add: #test5ConsumoPlacaConGPU; add: #test5ConsumoPlacaSinGPU; add: #test5ConsumoDiscoSolido; add: #test5ConsumoPC; yourself)); add: (#failures->((Set new) add: #testConsumoMonitorLCDEntradaVGA; yourself)); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 14280; instVarAt: 2 put: (Duration seconds: -10800 nanoSeconds: 0); instVarAt: 3 put: 2456396; instVarAt: 4 put: 959000000; yourself)); yourself)! !

!TPTests methodsFor: 'running' stamp: 'SantiagoOcchiuzzi 4/14/2013 08:35'!
setUp
super setUp .


	

	
	! !

!TPTests methodsFor: 'tests' stamp: 'LucasCostas 4/18/2013 20:32'!
testConsumoMonitorLCDEntradaVGA
	
	| entrada lg19Widescreen|
	lg19Widescreen := MonitorLCD new.
	lg19Widescreen tamanio:19.
	lg19Widescreen pixelesPorPulgada:100.
	
	entrada := EntradaVGA crearVGAconDefinicion: 1024.
	lg19Widescreen entrada: entrada.
	self assert: (lg19Widescreen consumoPorHoraReal) equals: ((4*19) + (0.001*1024)).! !

!TPTests methodsFor: 'tests' stamp: 'LucasCostas 4/18/2013 20:45'!
testConsumoSmartTVEntradaHDMI
	
	| entrada  philips32 |
	philips32 := SmartTV new.
	philips32 tamanio: 32.
	philips32 pixelesPorPulgada: 200.
	
	entrada := EntradaHDMI crearHDMIConDefinicion: 1920 yTasaRefresco: 0.
	philips32 entrada: entrada.
	self assert: (philips32 consumoPorHoraReal) equals: (1*32*1.2).! !

!TPTests methodsFor: 'tests' stamp: 'SantiagoOcchiuzzi 4/18/2013 03:29'!
testConsumoTVCRTEntradaAudioVideo
	
	| entrada  daewoo28 |
	daewoo28 := TVCRT new.
	daewoo28 tamanio: 28.
	daewoo28 pixelesPorPulgada: 50.
	
	entrada := EntradaAudioVideo new.
	daewoo28 entrada: entrada.
	self assert: (daewoo28 consumoPorHoraReal) equals: (5*28*1.1).! !

!TPTests methodsFor: 'tests' stamp: 'SantiagoOcchiuzzi 4/18/2013 03:29'!
testDefinicionMaximaDeLCD

	| entrada lg19Widescreen|
	lg19Widescreen := MonitorLCD new.
	lg19Widescreen tamanio:19.
	lg19Widescreen pixelesPorPulgada:100.
		
	self assert: lg19Widescreen definicionMaxima equals: 100*(((19 raisedTo: 2)/2) sqrt).! !

!TPTests methodsFor: 'tests' stamp: 'LucasCostas 4/18/2013 20:46'!
testDefinicionMaximaDeLCDConEntrada

	| entrada lg19Widescreen|
	lg19Widescreen := MonitorLCD new.
	lg19Widescreen tamanio:19.
	lg19Widescreen pixelesPorPulgada:100.
	
	entrada := EntradaVGA crearVGAconDefinicion: 1024.
	lg19Widescreen entrada: entrada. "1024 es menor que 1343.5, entonces va a tener esa definicin"
	
	self assert: lg19Widescreen definicionMaximaReal equals: 1024.! !

!TPTests methodsFor: 'tests' stamp: 'LucasCostas 4/18/2013 20:46'!
testNoPuedeConectarEntradaHDMIEnCRT

	| entrada lg19Widescreen|
	lg19Widescreen := MonitorCRT new.
	lg19Widescreen tamanio:15.
	lg19Widescreen pixelesPorPulgada:50.
	
	entrada := EntradaHDMI crearHDMIConDefinicion: 1600 yTasaRefresco: 0.
	self assert: ((lg19Widescreen sePuedeConectar:  entrada) not).! !

!TPTests methodsFor: 'tests' stamp: 'LucasCostas 4/18/2013 20:47'!
testPantallaNoPuedeUsarseParaVideojuegos

	| entrada tvPhilips|
	tvPhilips := TVLCD new.
	tvPhilips tamanio: 30.
	tvPhilips pixelesPorPulgada: 100.
	
	entrada := EntradaVGA crearVGAconDefinicion: 1024.
	tvPhilips entrada: entrada.
	self assert: (tvPhilips esBuenoParaJugarVideojuegos not). "La tasa de refresco de un TV normal es menor a la recomendable para jugar juegos"! !

!TPTests methodsFor: 'tests' stamp: 'LucasCostas 4/18/2013 20:47'!
testPantallaPuedeUsarseParaVideojuegos

	| entrada samsung27|
	samsung27 := MonitorLED new.
	samsung27 tamanio: 27.
	samsung27 pixelesPorPulgada: 150.
	
	entrada := EntradaHDMI crearHDMIConDefinicion: 1920 yTasaRefresco: 230.
	samsung27 entrada: entrada.
	self assert: (samsung27 esBuenoParaJugarVideojuegos). ! !

!TPTests methodsFor: 'tests' stamp: 'LucasCostas 4/18/2013 20:47'!
testSePuedeConectarEntradaVGAEnLCD

	| entrada lg19Widescreen|
	lg19Widescreen := MonitorLCD new.
	lg19Widescreen tamanio:19.
	lg19Widescreen pixelesPorPulgada:100.
	
	entrada := EntradaVGA crearVGAconDefinicion: 1024.
	self assert: (lg19Widescreen sePuedeConectar:  entrada).! !

!TPTests methodsFor: 'tests' stamp: 'CarlosManoja 4/18/2013 02:40'!
test_CPU_Consumo
	" Testeo del consumo total de una CPU completa."

	| unCPU unDisco unaPdV |

	unaPdV := PdVConGPU newPxDeAltura: 1366 pxDeBase: 768 yCantDeCoolers: 5. 
	unDisco := DiscoSolido newConRPM: 7000.
	unCPU := CPU newConDisco: unDisco yPlaca: unaPdV.
	
	self assert: (unCPU consume) equals: (22.99088).

! !

!TPTests methodsFor: 'tests' stamp: 'CarlosManoja 4/17/2013 18:36'!
test_DiscoMagnetico_Consumo
	" Testeo del consumo de un disco magnetico."

	| unDisco |

	unDisco := DiscoMagnetico newConRPM: 7000.
	
	self assert: (unDisco consume) equals:  (42).
! !

!TPTests methodsFor: 'tests' stamp: 'CarlosManoja 4/17/2013 18:36'!
test_DiscoSolido_Consumo
	" Testeo del consumo de un disco solido."

	| unDisco |

	unDisco := DiscoSolido newConRPM: 7000.
	
	self assert: (unDisco consume) equals: (10).

	unDisco := DiscoSolido newConRPM: 7000 yConsumoDe: 15.
	
	self assert: (unDisco consume) equals: (15).! !

!TPTests methodsFor: 'tests' stamp: 'CarlosManoja 4/18/2013 15:52'!
test_PlacaConGPU_AptoParaJuegos
	" Testeo si una placa de video con GPU es apta para videojuegos."

	| unaPdV |

	unaPdV := PdVConGPU newPxDeAltura: 1366 pxDeBase: 768 yCantDeCoolers: 5. 
	
	self assert: (unaPdV aptoParaJuegos) equals: (true).
! !

!TPTests methodsFor: 'tests' stamp: 'CarlosManoja 4/18/2013 01:13'!
test_PlacaConGPU_Consumo
	" Testeo del consumo de una placa de video con GPU."

	| unaPdV |

	unaPdV := PdVConGPU newPxDeAltura: 1366 pxDeBase: 768 yCantDeCoolers: 5. 
	
	self assert: (unaPdV consume) equals: (12.99088).
! !

!TPTests methodsFor: 'tests' stamp: 'CarlosManoja 4/18/2013 15:53'!
test_PlacaOnBoard_AptoParaJuegos
	" Testeo si una placa de video onboard es apta para videojuegos."

	| unaPdV |

	unaPdV := PdVOnBoard newPxDeAltura: 1366 pxDeBase: 768 yCantDeCoolers: 5. 
	
	self assert: (unaPdV aptoParaJuegos) equals: (false).

	unaPdV := PdVOnBoard newPxDeAltura: 1920 pxDeBase: 1080 CantDeCoolers: 1 yConsumoDe: 1. 
	
	self assert: (unaPdV aptoParaJuegos) equals: (false).! !

!TPTests methodsFor: 'tests' stamp: 'CarlosManoja 4/18/2013 02:37'!
test_PlacaOnBoard_Consumo
	" Testeo del consumo de una placa de video onboard."

	| unaPdV |

	unaPdV := PdVOnBoard newPxDeAltura: 1366 pxDeBase: 768 yCantDeCoolers: 5. 
	
	self assert: (unaPdV consume) equals: (12.5).

	unaPdV := PdVOnBoard newPxDeAltura: 1920 pxDeBase: 1080 CantDeCoolers: 1 yConsumoDe: 1. 
	
	self assert: (unaPdV consume) equals: (1.5).! !

!TPTests methodsFor: 'tests' stamp: 'CarlosManoja 4/18/2013 02:29'!
test_PlacaSinGPU_AptoParaJuegos
	" Testeo si una placa de video sin GPU es apta para videojuegos."

	| unaPdV |

	unaPdV := PdVSinGPU newPxDeAltura: 1366 pxDeBase: 768 yCantDeCoolers: 5. 
	
	self assert: (unaPdV aptoParaJuegos) equals: (false).

	unaPdV := PdVSinGPU newPxDeAltura: 1920 pxDeBase: 1080 CantDeCoolers: 1 yConsumoDe: 1. 
	
	self assert: (unaPdV aptoParaJuegos) equals: (true).! !

!TPTests methodsFor: 'tests' stamp: 'CarlosManoja 4/18/2013 02:32'!
test_PlacaSinGPU_Consumo
	" Testeo del consumo de una placa de video sin GPU."

	| unaPdV |

	unaPdV := PdVSinGPU newPxDeAltura: 1366 pxDeBase: 768 yCantDeCoolers: 5. 
	
	self assert: (unaPdV consume) equals: (12.5).

	unaPdV := PdVSinGPU newPxDeAltura: 1920 pxDeBase: 1080 CantDeCoolers: 1 yConsumoDe: 1. 
	
	self assert: (unaPdV consume) equals: (1.5).! !

Object subclass: #CPU
	instanceVariableNames: 'PlacaDeVideo Disco'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

!CPU class methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 00:36'!
newConDisco: unDisco yPlaca: unaPlaca
	"Crea un CPU con un disco y placa especifica"

	|newCPU|

	newCPU := self new.
	newCPU disco: unDisco.
	newCPU placaDeVideo: unaPlaca.
	^ newCPU.! !

!CPU methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 4/18/2013 16:39'!
aptoParaJuegos
	"Define si una CPU es apta para videojuegos"

	 ^self placaDeVideo aptoParaJuegos.! !

!CPU methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 00:49'!
consume
	"consumo total del CPU"

	| consumoTT |
	consumoTT := self disco consume + self placaDeVideo consume.
	^consumoTT.! !

!CPU methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 17:34'!
disco
	^ Disco! !

!CPU methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 17:34'!
disco: anObject
	Disco := anObject! !

!CPU methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 17:34'!
placaDeVideo
	^ PlacaDeVideo! !

!CPU methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 17:34'!
placaDeVideo: anObject
	PlacaDeVideo := anObject! !

Object subclass: #Disco
	instanceVariableNames: 'rpm'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

!Disco commentStamp: '<historical>' prior: 0!
A Disco is xxxxxxxxx.

Instance Variables
	rpm:		<Object>

rpm
	- Revoluciones por minutos del disco
!

!Disco class methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 00:35'!
newConRPM: unRPM
	"Crea un disco con un RPM especifico"

	|newDisco|

	newDisco := self new.
	newDisco rpm: unRPM.
	^ newDisco.! !

!Disco methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 17:56'!
rpm
	^ rpm! !

!Disco methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 17:56'!
rpm: anObject
	rpm := anObject! !

Disco subclass: #DiscoMagnetico
	uses: Magnetico
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

DiscoMagnetico class
	uses: Magnetico classTrait
	instanceVariableNames: ''!

Disco subclass: #DiscoSolido
	uses: Solido
	instanceVariableNames: 'consumo'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

DiscoSolido class
	uses: Solido classTrait
	instanceVariableNames: ''!

!DiscoSolido class methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 4/17/2013 16:57'!
newConRPM: unRPM 
	"Crea un disco de estado solido con un RPM especifico y consumo de 10 watts/h"

	|newDisco|

	newDisco := super newConRPM: unRPM.
	newDisco consumo: 10.
	^ newDisco.! !

!DiscoSolido class methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 4/17/2013 16:58'!
newConRPM: unRPM yConsumoDe: unConsumo
	"Crea un disco de estado solido con un RPM y consumo especificos"

	|newDisco|

	newDisco := super newConRPM: unRPM.
	newDisco consumo: unConsumo.
	^ newDisco.! !

!DiscoSolido methodsFor: 'accessing' stamp: 'CarlosManoja 4/17/2013 16:27'!
consumo
	^ consumo! !

!DiscoSolido methodsFor: 'accessing' stamp: 'CarlosManoja 4/17/2013 16:27'!
consumo: anObject
	consumo := anObject! !

Object subclass: #Entrada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

!Entrada methodsFor: 'as yet unclassified' stamp: 'LucasCostas 4/18/2013 20:26'!
consumoPorHoraDe: unaPantalla
	self subclassResponsibility ! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'LucasCostas 4/18/2013 20:26'!
definicionMaxima
	self subclassResponsibility ! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'LucasCostas 4/18/2013 20:26'!
tasaDeRefresco
	self subclassResponsibility! !

Entrada subclass: #EntradaAudioVideo
	uses: EntradaValoresFijos - {#tasaRefresco. #definicion} + EntradaQueAgregaPorcentajeDeConsumo - {#consumoAgregadoA:}
	instanceVariableNames: 'porcentajeAgregado'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

EntradaAudioVideo class
	uses: EntradaValoresFijos classTrait + EntradaQueAgregaPorcentajeDeConsumo classTrait
	instanceVariableNames: ''!

!EntradaAudioVideo methodsFor: 'as yet unclassified' stamp: 'LucasCostas 4/18/2013 15:35'!
porcentajeAgregado 
	^0.1! !

Entrada subclass: #EntradaHDMI
	uses: EntradaConCable - {#tasaRefresco. #definicion} + EntradaQueAgregaPorcentajeDeConsumo - {#consumoAgregadoA:}
	instanceVariableNames: 'cableDefinicion cableTasaRefresco porcentajeAgregado'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

EntradaHDMI class
	uses: EntradaConCable classTrait + EntradaQueAgregaPorcentajeDeConsumo classTrait
	instanceVariableNames: 'cableDefinicion'!

EntradaHDMI class
	uses: EntradaConCable classTrait + EntradaQueAgregaPorcentajeDeConsumo classTrait
	instanceVariableNames: 'cableDefinicion'!

!EntradaHDMI class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 4/18/2013 20:36'!
crearHDMIConDefinicion: unaDefinicion yTasaRefresco: unaTasa
	| nuevaHDMI |
	
	nuevaHDMI := EntradaHDMI new.
	nuevaHDMI cableDefinicion: unaDefinicion.
	nuevaHDMI cableTasaRefresco: unaTasa.
	^nuevaHDMI .! !

!EntradaHDMI methodsFor: 'getters&setters' stamp: 'LucasCostas 4/18/2013 14:59'!
cableDefinicion 
	^cableDefinicion ! !

!EntradaHDMI methodsFor: 'getters&setters' stamp: 'LucasCostas 4/18/2013 14:58'!
cableDefinicion: unaDefinicion
	cableDefinicion := unaDefinicion ! !

!EntradaHDMI methodsFor: 'getters&setters' stamp: 'LucasCostas 4/18/2013 14:59'!
cableTasaRefresco 
	^cableTasaRefresco ! !

!EntradaHDMI methodsFor: 'getters&setters' stamp: 'LucasCostas 4/18/2013 14:58'!
cableTasaRefresco: unaTasa
	cableTasaRefresco := unaTasa ! !

!EntradaHDMI methodsFor: 'getters&setters' stamp: 'LucasCostas 4/18/2013 15:37'!
porcentajeAgregado 
	^0.2.! !

Entrada subclass: #EntradaRF
	uses: EntradaValoresFijos - {#tasaRefresco. #definicion} + EntradaQueAgregaPorcentajeDeConsumo - {#consumoAgregadoA:}
	instanceVariableNames: 'porcentajeAgregado'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

EntradaRF class
	uses: EntradaValoresFijos classTrait + EntradaQueAgregaPorcentajeDeConsumo classTrait
	instanceVariableNames: ''!

!EntradaRF methodsFor: 'as yet unclassified' stamp: 'LucasCostas 4/18/2013 15:39'!
porcentajeAgregado 
	^0! !

Entrada subclass: #EntradaVGA
	uses: EntradaConCable - {#tasaRefresco. #definicion}
	instanceVariableNames: 'pixeles cableDefinicion cableTasaRefresco'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

EntradaVGA class
	uses: EntradaConCable classTrait
	instanceVariableNames: ''!

!EntradaVGA class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 4/18/2013 20:30'!
crearVGAconDefinicion: unaDefinicion
	| nuevaVGA |
	
	nuevaVGA := EntradaVGA new.
	nuevaVGA cableDefinicion: unaDefinicion.
	nuevaVGA cableTasaRefresco: 120.
	^nuevaVGA.! !

!EntradaVGA methodsFor: 'getters&setters' stamp: 'LucasCostas 4/18/2013 15:08'!
cableDefinicion 
	^cableDefinicion ! !

!EntradaVGA methodsFor: 'getters&setters' stamp: 'LucasCostas 4/18/2013 15:07'!
cableDefinicion: unaDefinicion
	cableDefinicion := unaDefinicion ! !

!EntradaVGA methodsFor: 'getters&setters' stamp: 'LucasCostas 4/18/2013 15:08'!
cableTasaRefresco 
	^cableTasaRefresco ! !

!EntradaVGA methodsFor: 'getters&setters' stamp: 'LucasCostas 4/18/2013 15:08'!
cableTasaRefresco: unaTasa 
	cableTasaRefresco := unaTasa.! !

!EntradaVGA methodsFor: 'as yet unclassified' stamp: 'LucasCostas 4/18/2013 20:42'!
consumoPorHoraDe:  unaPantalla
	^ 0.001* self definicionMaxima.! !

Object subclass: #Pantalla
	instanceVariableNames: 'tamanio entrada ppp'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

Pantalla subclass: #MonitorCRT
	uses: MonitorPC + CRT - {#tamanio}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

MonitorCRT class
	uses: MonitorPC classTrait + CRT classTrait
	instanceVariableNames: ''!

Pantalla subclass: #MonitorLCD
	uses: MonitorPC + LCD - {#pixelesPorPulgada. #tamanio}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

!MonitorLCD commentStamp: '<historical>' prior: 0!
Un MonitorLCD es la combinacin de esas dos cosas usando Traits.!

MonitorLCD class
	uses: MonitorPC classTrait + LCD classTrait
	instanceVariableNames: ''!

Pantalla subclass: #MonitorLED
	uses: MonitorPC + LED - {#pixelesPorPulgada. #tamanio}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

MonitorLED class
	uses: MonitorPC classTrait + LED classTrait
	instanceVariableNames: ''!

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/18/2013 03:26'!
consumoPorHoraReal 
^self consumoPorHora + (entrada consumoPorHoraDe: self ).! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/18/2013 03:26'!
definicionMaximaReal
^self entrada definicionMaxima.
"No se puede conectar un cable de definicin mayor al que permita la pantalla, entonces, la definicin mxima siempre va a ser la del cable"! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:09'!
entrada
^entrada.! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/18/2013 03:25'!
entrada: unaEntrada.
(self sePuedeConectar: unaEntrada)
	ifTrue: [entrada:=unaEntrada ]
"Si esto no fuese as, deberamos tirar una excepcin o algo."! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/18/2013 03:26'!
esBuenoParaJugarVideojuegos
	^self tasaDeRefrescoReal >100.! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:38'!
pixelesPorPulgada
^ppp.! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:38'!
pixelesPorPulgada:pixeles
ppp:=pixeles.! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/18/2013 03:26'!
sePuedeConectar: unaEntrada
^(unaEntrada definicionMaxima) <= (self definicionMaxima).! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:07'!
tamanio
^tamanio.! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:07'!
tamanio: pulgadas
tamanio := pulgadas.! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/18/2013 03:27'!
tasaDeRefrescoReal
(self entrada tasaDeRefresco < self tasaDeRefresco )
	ifTrue: [^self entrada tasaDeRefresco]
	ifFalse: [^self tasaDeRefresco ].! !

Pantalla subclass: #SmartTV
	uses: TV @ {#tasaDeRefrescoEstandar->#tasaDeRefresco} + LED - {#pixelesPorPulgada. #tamanio}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

!SmartTV commentStamp: '<historical>' prior: 0!
Es casi igual que un TV LED. Difiere en la tasa de refresco, y se abre a futuros nuevos requerimientos :)!

SmartTV class
	uses: TV classTrait + LED classTrait
	instanceVariableNames: ''!

!SmartTV methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/14/2013 08:06'!
tasaDeRefresco
^(self tasaDeRefrescoEstandar)*1.5.! !

Pantalla subclass: #TVCRT
	uses: TV + CRT - {#pixelesPorPulgada. #tamanio}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

TVCRT class
	uses: TV classTrait + CRT classTrait
	instanceVariableNames: ''!

Pantalla subclass: #TVLCD
	uses: TV + LCD - {#pixelesPorPulgada. #tamanio}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

TVLCD class
	uses: TV classTrait + LCD classTrait
	instanceVariableNames: ''!

Pantalla subclass: #TVLED
	uses: TV + LED - {#pixelesPorPulgada. #tamanio}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

TVLED class
	uses: TV classTrait + LED classTrait
	instanceVariableNames: ''!

Object subclass: #PdV
	uses: PlacaDeVideo
	instanceVariableNames: 'pxAltura pxBase nroDeCoolers'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

PdV class
	uses: PlacaDeVideo classTrait
	instanceVariableNames: ''!

!PdV class methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 4/17/2013 17:13'!
newPxDeAltura: unPxAlt pxDeBase: unPxBase yCantDeCoolers: unaCantDeCoolers 
	"Crea una placa de video con una altura, una base (medidas en pixeles) y una cantidad de coolers especificas"

	|newPdV|

	newPdV := self new.
	newPdV pxAltura: unPxAlt.
	newPdV pxBase: unPxBase.
	newPdV nroDeCoolers: unaCantDeCoolers.
	^ newPdV.! !

!PdV methodsFor: 'accessing' stamp: 'CarlosManoja 4/18/2013 02:05'!
cantDePixeles
	^ self pxAltura * self pxBase.! !

!PdV methodsFor: 'accessing' stamp: 'CarlosManoja 4/17/2013 16:34'!
nroDeCoolers
	^ nroDeCoolers! !

!PdV methodsFor: 'accessing' stamp: 'CarlosManoja 4/17/2013 16:34'!
nroDeCoolers: anObject
	nroDeCoolers := anObject! !

!PdV methodsFor: 'accessing' stamp: 'CarlosManoja 4/17/2013 16:34'!
pxAltura
	^ pxAltura! !

!PdV methodsFor: 'accessing' stamp: 'CarlosManoja 4/17/2013 16:34'!
pxAltura: anObject
	pxAltura := anObject! !

!PdV methodsFor: 'accessing' stamp: 'CarlosManoja 4/17/2013 16:34'!
pxBase
	^ pxBase! !

!PdV methodsFor: 'accessing' stamp: 'CarlosManoja 4/17/2013 16:34'!
pxBase: anObject
	pxBase := anObject! !

PdV subclass: #PdVConGPU
	uses: PdVDeConsumoCalculado + PdVAptoPVJBooleano @ {#aptoParaJuegos->#siAptoParaJuegos} - {#noAptoParaJuegos}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

PdVConGPU class
	uses: PdVDeConsumoCalculado classTrait + PdVAptoPVJBooleano classTrait
	instanceVariableNames: ''!

PdV subclass: #PdVNoConGPU
	uses: PdVDeConsumoCte
	instanceVariableNames: 'consumo'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

PdVNoConGPU class
	uses: PdVDeConsumoCte classTrait
	instanceVariableNames: ''!

!PdVNoConGPU class methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 4/18/2013 02:26'!
newPxDeAltura: unPxAlt pxDeBase: unPxBase CantDeCoolers: unaCantDeCoolers yConsumoDe: unConsumo
	"Crea una placa de video con una altura, una base (medidas en pixeles), una cantidad de coolers y un consumo especificos"

	|newPdV|

	newPdV := super newPxDeAltura: unPxAlt pxDeBase: unPxBase yCantDeCoolers: unaCantDeCoolers.
	newPdV consumo: unConsumo.
	^ newPdV.! !

!PdVNoConGPU class methodsFor: 'as yet unclassified' stamp: 'CarlosManoja 4/18/2013 00:51'!
newPxDeAltura: unPxAlt pxDeBase: unPxBase yCantDeCoolers: unaCantDeCoolers 
	"Crea una placa de video con una altura, una base (medidas en pixeles) y una cantidad de coolers especificas, y un consumo de 10 watts/h"

	|newPdV|

	newPdV := super newPxDeAltura: unPxAlt pxDeBase: unPxBase yCantDeCoolers: unaCantDeCoolers.
	newPdV consumo: 10.
	^ newPdV.! !

!PdVNoConGPU methodsFor: 'accessing' stamp: 'CarlosManoja 4/18/2013 00:02'!
consumo
	^ consumo! !

!PdVNoConGPU methodsFor: 'accessing' stamp: 'CarlosManoja 4/18/2013 00:02'!
consumo: anObject
	consumo := anObject! !

PdVNoConGPU subclass: #PdVOnBoard
	uses: PdVDeConsumoCte + PdVAptoPVJBooleano @ {#aptoParaJuegos->#noAptoParaJuegos} - {#siAptoParaJuegos}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

PdVOnBoard class
	uses: PdVDeConsumoCte classTrait + PdVAptoPVJBooleano classTrait
	instanceVariableNames: ''!

PdVNoConGPU subclass: #PdVSinGPU
	uses: PdVDeConsumoCte + PdVAptoPVJCalculado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

PdVSinGPU class
	uses: PdVDeConsumoCte classTrait + PdVAptoPVJCalculado classTrait
	instanceVariableNames: ''!
